<div id="body" class="container-fluid">
  <div class="row mx-n5">
    <div class="col">
      <h6>Search CPT</h6>
      <form [formGroup]="form" novalidate>
        <mat-accordion>
          <mat-expansion-panel [expanded]="true" class="mb-1">
            <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
              <mat-panel-title><h6>General</h6></mat-panel-title>
            </mat-expansion-panel-header>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-24 col-lg-4">CPT #</label>
                <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                  <input type="text" class="form-control form-control-sm" formControlName="cptCustNbr" />
                </div>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-24 col-lg-4">Company Name</label>
                <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                  <input type="text" class="form-control form-control-sm" formControlName="companyName" />
                </div>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-24 col-lg-4">Customer Short Name</label>
                <div class="col-24 col-lg-20 pl-0 pl-lg-1">
                  <input type="text" class="form-control form-control-sm" formControlName="custShortName" />
                </div>
              </div>
            </div>
            <div class="form-row text-center">
              <div class="form-group form-group-sm col-12 col-md-6 col-lg-3 offset-md-6 offset-lg-8">
                <button type="button" class="btn btn-sm btn-primary btn-block" (click)="search()">Search</button>
              </div>
              <div class="form-group form-group-sm col-12 col-md-6 col-lg-3">
                <button type="reset" class="btn btn-sm btn-secondary btn-block" (click)="clear()">Clear</button>
              </div>
            </div>
          </mat-expansion-panel>
        </mat-accordion>

        <div class="mb-1" *ngIf="cptList?.length > 0">
          <dx-data-grid #grid id="grid" [dataSource]="cptList" keyExpr="cptId" [wordWrapEnabled]="true"
                        [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true"
                        (onRowPrepared)="onRowPrepared($event)" (onExporting)="onExporting($event)"
                        (onRowDblClick)="selectionChangedHandler(grid.selectedRowKeys)"
                        (onToolbarPreparing)="onToolbarPreparing($event)"
                        (onContentReady)="grid.instance.searchByText(grid.searchPanel.text.trim())">
            <dxo-sorting mode="multiple"></dxo-sorting>
            <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
            <dxo-selection mode="single"></dxo-selection>
            <dxo-paging [pageSize]="50"></dxo-paging>
            <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
            <dxo-search-panel [visible]="true" [highlightCaseSensitive]="true"></dxo-search-panel>
            <dxi-column dataField="cptCustNbr" caption="CPT #" dataType="string"
                        [minWidth]="100" cellTemplate="linkIdTemplate"></dxi-column>
            <dxi-column dataField="h1" caption="H1" dataType="string" [minWidth]="100"></dxi-column>
            <dxi-column dataField="companyName" caption="Company Name"
                        dataType="string" [minWidth]="150"></dxi-column>
            <dxi-column dataField="cntDevices" caption="Number of Devices"
                        dataType="number" [minWidth]="150" alignment="left"></dxi-column>
            <dxi-column dataField="custShortName" caption="Short Name"
                        dataType="string" [minWidth]="150"></dxi-column>
            <dxi-column dataField="createdBy" caption="Submitter Name"
                        dataType="string" [minWidth]="200"></dxi-column>
            <dxi-column dataField="createdDateTime" caption="Created Date" cellTemplate="localStartTime"
                        dataType="string" [minWidth]="150"></dxi-column>
            <div *dxTemplate="let cell of 'localStartTime'">
              <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
            </div>
            <div *dxTemplate="let data of 'exportTemplate'">
              <button type="button" class="btn btn-sm btn-primary"
                      (click)="grid.instance.exportToExcel(false)">
                Export to Excel
              </button>
            </div>
            <div *dxTemplate="let row of 'linkIdTemplate'">
              <a class="hyperlink" (click)="selectionChangedHandler(row.data.cptId)">{{ row.value }}</a>
            </div>
          </dx-data-grid>
        </div>
      </form>
    </div>
  </div>
</div>
